<?php

namespace Luticate\Auth\Business;

use Luticate\Utils\LuBusiness;
use Luticate\Auth\DataAccess\LuticateSettingsUsersDataAccess;
use Luticate\Auth\DBO\LuticateSettingsUsersDbo;
use Luticate\Utils\LuMultipleDbo;

class LuticateSettingsUsersBusiness extends LuBusiness {
    protected static function getDataAccess()
    {
        return new LuticateSettingsUsersDataAccess();
    }

    public static function checkSettingUserName($user_id, $setting_name)
    {
        LuticateUsersBusiness::checkUserId($user_id);
        LuticateSettingsBusiness::checkSettingName($setting_name);
        $setting = LuticateSettingsUsersDataAccess::getByName($user_id, $setting_name);
        if (is_null($setting)) {
            self::notFound("User setting not found");
        }
        return $setting;
    }

    public static function getAllByUser($user_id, $page = 0, $perPage = 2000000000)
    {
        return LuticateSettingsUsersDataAccess::getAllByUser($user_id, $page, $perPage);
    }

    public static function edit($user_id, $setting_name, $setting_value)
    {
        $setting_value = json_decode($setting_value);
        LuticateUsersBusiness::checkUserId($user_id);
        $setting = LuticateSettingsBusiness::checkSettingName($setting_name);
        if (is_null($setting_value)) {
            LuticateSettingsUsersDataAccess::delete($user_id, $setting_name);
        } else {
            $setting->setValue($setting_value);
            LuticateSettingsBusiness::checkSetting($setting);
            $setting_value = json_encode($setting_value);
            $user_setting = LuticateSettingsUsersDataAccess::getByName($user_id, $setting_name);
            if (is_null($user_setting)) {
                $user_setting = new LuticateSettingsUsersDbo();
                $user_setting->setName($setting_name);
                $user_setting->setValue($setting_value);
                $user_setting->setUserId($user_id);
                LuticateSettingsUsersDataAccess::add($user_setting);
            }
            else {
                $user_setting->setValue($setting_value);
                LuticateSettingsUsersDataAccess::edit($user_setting);
            }
        }
        return true;
    }
}